---
title: "Is Encryption Worth It?"
layout: post
author: tait
---

What is the most embarassing thing you have typed into Google search? What is the most personal secret you told a friend in confidence? What is your bank password? What is your business's secret to stay ahead of the competition?

Now at first these questions may seem not completely related. There is a point though: You likely sent all of this information over the internet.

When you send that messege to your friend or business partner, why is it that any person can't just listen to the signals coming from your phone or laptop and know what you sent to your friend or colleague? The answer: encryption.

First, some background about internet privacy. You can't have a conversation about internet encryption and privacy without discussing the man himself:

### Snowden

[Edward Joseph Snowden](https://en.wikipedia.org/wiki/Edward_Snowden){:target="_blank"} is an ex-NSA, ex-CIA employee who felt the [United State's 4th Ammendment](https://en.wikipedia.org/wiki/Fourth_Amendment_to_the_United_States_Constitution){:target="_blank"} was being violated by their programs of msas survailence.
Snowden was raised a staunch establishmentarian conservative; his girlfriend Lisndey however, slowly started changing his mind. Snowden became very influenced by the ideology of [populism](https://en.wikipedia.org/wiki/Populism){:target="_blank"}.
His populist thinking is shown very clearly when he explains his reasoning for his disclosure of humongous troves of NSA documents.

> "My sole motive is to inform the public as to that which is done in their name and that which is done against them."
> ---[Edward Snowden](https://www.theguardian.com/world/video/2013/jun/09/nsa-whistleblower-edward-snowden-interview-video){:target="_blank"}

Snowden's first set of leaks went public in [The Gaurdian](https://www.theguardian.com/world/2013/sep/05/nsa-gchq-encryption-codes-security){:target="_blank"}, [The New York Times](https://www.nytimes.com/2013/06/10/us/former-cia-worker-says-he-leaked-surveillance-data.html){:target="_blank"}, and [ProPublica](https://www.propublica.org/article/the-nsas-secret-campaign-to-crack-undermine-internet-encryption){:target="_blank"} in late 2013;
people started to realize that their governments and internet service providers (ISPs) **are** listening. People understood there might be more sinister motives than "national security" at play.

Personally, I have seen a lot of non-tech-savy individuals using security-conscious software when I am helping them fix a problem.
In fact, there was one time I saw a collage student from rural Alberta who had a VPN running on her phone. This impressed me!

### Encryption on The Web

The type of encryption used on the web is called: HyperText Transfer Protocol--Secure (HTTPS).
This kind of encryption stops two things from happening: A) it stops the information you are sending and recieving online from being seen by easvesdroppers and criminals, and B) stops those same third-parties from tampering with the data.

Without HTTPS it is possible for sombody to listen in and change the data being sent between you and a server.

Only in recent years has HTTPS become near-universal across the web. It is used even on the simplest sites these days: this one included. After 2013, people became weary of government, criminal, and ISP interference with their web traffic.
This can be backed up by statistics:
The level of encrypted web traffic around the time of the Snowden leaks was around 30 percent. It was mostly used by banks, email providers, government, and journalists.
At the turn of the 2020s however, this has risen to nearly 90 percent among U.S. users of Firefox.
Japan lags slightly behind with 80 percent encrypted traffic.

<figure>
  <img src="/assets/img/encrypted-web-traffic.png" alt="Use of encrypted web traffic incresing over time.">
  <figcaption>
    More at: <a href="https://letsencrypt.org/stats/" target="_blank">Let's Encrypt</a>
  </figcaption>
</figure>

This is just the data we know of. You can disable the [telemetry](https://en.wikipedia.org/wiki/Telemetry#Software){:target="_blank"} settings in Firefox, and it is very likely that hardcore privacy advocates would disable this data collection, so perhaps the amount of encrypted web traffic is slightly higher.

### What about RSA?

RSA is an encryption method named after the initials of the inventors' sir names: Ron **R**ivest, Adi **S**hamir, and Leonard **A**dleman. It uses the mathematical "factoring problem" to secure communication. The details of this specific type of encryption will be discussed in an article soon to come.

