---
title: "Curiosity"
layout: post
---

Curiosity is fundamental to a deep understanding of any subject.
Masters, Ph.Ds, and other fancy name suffixes will never help you
if you don't have the spirit of curiosity burning inside of you.

I was speaking to someone from a journalism major at my school when the subject of hacking arose.
I expected her to know nothing about it, being a journalism student and all, but surprisingly she had something to say about it:

> "The best hackers are the ones who are curious."

That struck a cord with me.
It seems to me she has nailed down the difference between the students who care about grades,
and those who want to learn.
These are not necessarily mutually exclusive, but in my experience they often are due to the way education is structured.

## My Anecdote

In my second semester at SAIT Polytechnic, I took a class entitled *Emerging Trends In Technology*.
This class was probably the best class I have ever taken.
We had to combine two things:

* **Hard skills**: learning a new hard skill like Angular, Django, or GPG encryption.
* **Soft skills**: public speaking and presentation of our ideas.

Soft skills are not usually my area, but I can do public speaking.
I grew up quite religious, so public speaking was drilled into me young.
I liked to go off script and talk about interesting things I found along the way to the actual point.
My creativity was not usually encouraged.
That said, going off script is useful when teaching and presenting ideas;
it gives a natural air to your breath and an unquestionable confidence in your speech.

This is how we learn: in relationships.
Try explaining ancient Japanese history to a computer science major, or UNIX sockets to an English major and you'll see what I mean.
If there is nothing for us to connect the knowledge to, it dissipates.

So why did I do so well in this class?

Our task for the semester was as follows:

1. Learn a new subject (any *emerging trend in technology*) which you find fascinating.
2. Give a one minute introduction by week three.
3. Give a 10 minute non-technical overview by week 8.
4. Give a 20 minute technical explaination and demo by week 13.

This is the only course I have ever taken which lets students' imagination run wild.
Their presentation, their rules.
They treated the students like adults who know what they are doing.
What happened? Everyone stopped coming because "Oh no! Presentations!"?

No, exactly the opposite.
There was never more than one student missing.
Every single presentation was at least moderately interesting,
and most students were excited to come to that class.
You could see it in their faces, the way they carried themselves.
Every student picked something unique to their tastes, leaving every student more educated than before.

This class, unlike many others, encouraged the curiosity of the students.
It rewarded those who had unique interests and an ability to sell others on their ideas.

The curiosity and the grades were one.

## Conclusion

Although it's nice to have a course where these goals align here and there, anyone who has been to collage or university can tell you that is far from the norm.

On the other hand, I never would have started this site if it wasn't for that class alone.
So I thank you, Kitty Wong, for getting me started running my own "research blog" (?)
